#ifndef PATCHDOWNLOADER_H
#define PATCHDOWNLOADER_H

#include <QObject>
#include <QList>
#include <QString>
#include <QMap>

#include "models/downloader.h"

class PatchDownloader : public QObject
{
    Q_OBJECT

public:
    static PatchDownloader& instance() {
        static PatchDownloader instance_;
        return instance_;
    }

    void init();
    ~PatchDownloader();

private:
    PatchDownloader();
    void checkForUpdates();  // Checks for updates. Returns true, if there are new patch updates
    void download();         // Downloads all necessary patches.
    static bool needDownloadDatabase(QString db_name); // Checks if database needs to be downloaded (by checksum comparing)

public slots:
    void startPatchDownloaderChain();

private:
    const QList<QString> patches_ = {"text", "font", "image", "texture", "loadscreen", "sound", "video"};
    QMap<QString, Downloader*> patch_downloaders_;
};

#endif // PATCHDOWNLOADER_H
